local core = {}
local socket=require("socket")
--local lovebird=require("lovebird")
--lovebird.whitelist=nil
core.lowq=false
core.touchmegaid=""
core.idcharset="QWERTYUIOPASDFGHJKLZXCVBNM1234567890"
core.click=love.audio.newSource("click.wav")
core.music=true
core.sounds=true
core.maxtraffic=0.1
core.version="2.3.5"
--core.unitid="ca-app-pub-7836559392002989/2806104582" -- Old Real ad
--core.unitid="ca-app-pub-3940256099942544/1033173712" -- Test ad
core.authors={
[[AUTHORS OF THIS GAME
Main developing - Dima Tillyaev
Code - Dima Tillyaev
Drawing - Nastya Tillyaeva]],
[[THANKS TO
Azhukar from love2d.org
Diablo from 2play.uz]],
[[Powered by love2d (a good engine)]],
}
core.help={
[[How to play:
Destroy other cars, protect yourself.
Only the strongest will survive! But there's no winner. This game is endless multiplayer.]],
[[Controls for computer:
[W],[A],[S],[D], Arrows - Move,
[E] - Autospin,
[G] - Gattling mode,
[H] - Supershot mode,
[B] - Boost mode,
[M] - Change bullet mode.
[LMB], [Space] - Shot]],
[[Controls for mobile:
Move joystick to move,
Tap to screen to shot
(multi-touch is not supported :( )]]}
function checkArg(n,v,t)
  if type(v) ~= t then
    error(string.format("bad argument #%i (%s expected, got %s)",n,t,type(v)),3)
  end
  return true
end
--core.s.serialize=require("s")
--function core.s.unserialize(s)
--  local ok,res = pcall(loadstring(loadstring(s)()))
--  return res
--end

--core.draws[1]=function()
--  for n=1,love.graphics.getWidth()*love.graphics.getHeight()*0.01*math.random() do
--    love.graphics.points(math.random(0,love.graphics.getWidth()),math.random(0,love.graphics.getHeight()))
--  end
--end
--do
--  local cbg=love.graphics.newImage("Controls.png")
--  table.insert(core.draws,function()local color={love.graphics.getColor()} love.graphics.setColor(255,255,255,64) if not love.mouse.hasCursor() then love.graphics.draw(cbg) end love.graphics.setColor(unpack(color))end)
--end

-- core.wrap(core.handlers.mousepressed,function(x,y,k,istouch) local xd,yd=core.getDimensionsRate() return func(x*xd,y*yd,k,istouch) end)
-- core.wrap(core.handlers.mousereleased,function(x,y,k,istouch) local xd,yd=core.getDimensionsRate() return func(x*xd,y*yd,k,istouch) end)
-- core.wrap(core.handlers.mousemoved,function(x,y,dx,dy) local xd,yd=core.getDimensionsRate() return func(x*xd,y*yd,dx*xd,dy*yd) end)
-- core.wrap(core.handlers.touchpressed,function(id,x,y,k,istouch) local xd,yd=core.getDimensionsRate() return func(id,x*xd,y*yd,k,istouch) end)
-- core.wrap(core.handlers.touchreleased,function(id,x,y,k,istouch) local xd,yd=core.getDimensionsRate() return func(id,x*xd,y*yd,k,istouch) end)
-- core.wrap(core.handlers.touchmoved,function(id,x,y,dx,dy) local xd,yd=core.getDimensionsRate() return func(idx*xd,y*yd,dx*xd,dy*yd) end)
local spheret=0
function core.start(func)
  local thread = coroutine.create(func)
  function res()
    if coroutine.status(thread) == "dead" then
      pcall(love.event.quit)
      return 1
    end
    local ok,err = coroutine.resume(thread)
    if not ok then
      error("FATAL ERROR!"..err)
    end
  end
  do
    local t=0
    local starttime=os.clock()
  --  debug.sethook(function() if t > 5 then t=0 print(core.dat("MAIN THREAD/DEBUG",debug.traceback("DBG MESSAGE"))) end t=t+os.clock()-starttime starttime=os.clock()end,"clr")
  end
  function love.run()
  local writech=love.thread.getChannel("w")
  if love.math then
    love.math.setRandomSeed(os.time())
  end
 
  if love.load then love.load(arg) end
  -- We don't want the first frame's dt to include time taken by love.load.
  if love.timer then love.timer.step() end
 
  local dt = 0
  -- Main loop time.
  local pressed=false
  -- local threadevent=love.thread.newThread([[
  
  -- require("love.event")
  -- while true do love.event.pump() end
  -- ]])
  -- threadevent:start()
  while true do
    res()
    local x=writech:pop()
    if x then
      io.write(x)
    end
    local nullfunc=function(...) return ... end
    -- Process events.
    if love.event then
      --local mx,my = love.mouse.getPosition()
      love.event.pump()
      --if threadevent:getError() then
      --  print(threadevent:getError())
      --end
      local xd,yd=core.getDimensionsRate()
      for name, a,b,c,d,e,f in love.event.poll() do
        if name == "quit" then
          if not love.quit or not love.quit() then
            core.saveSettings()
            return a
          end
        elseif name == "mousepressed" or name=="mousereleased" then
          a,b=a*xd,b*yd
        elseif name=="mousemoved" then
          a,b,c,d=a*xd,b*yd,c*xd,d*yd
        elseif name == "touchpressed" or name=="touchreleased" then
          b,c=b*xd,c*yd
        elseif name=="touchmoved" then
          b,c,d,e=b*xd,c*yd,d*xd,e*yd
        end
        if (not love.mouse.hasCursor()) and core.hasCursor() then
          if name=="mousepressed" then
            love.event.push("touchpressed",core.touchmegaid,a,b,0,0,1)
            spheret=1
          elseif name=="mousereleased" then
            love.event.push("touchreleased",core.touchmegaid,a,b,0,0,1)
            core.touchmegaid=core.randomid()
            spheret=1
          elseif name=="mousemoved" then
            love.event.push("touchmoved",core.touchmegaid,a,b,c,d,1)
            spheret=1
          end
        end
        --local tested=core.teste(name,a,b,c,d,e,f)
        --print("TESTED=",tested)
        --if not tested then
          --print("Passed event",name,a,b,c,d,e,f)
          love.handlers[name](a,b,c,d,e,f)
          local func = core.handlers[name] or nullfunc
          func(a,b,c,d,e,f)
        --else
          --print("Blocked event",name,a,b,c,d,e,f)
          --love.mouse.setPosition(mx,my)
        --end
      end
    end
 
    -- Update dt, as we'll be passing it to update
    if love.timer then
      love.timer.step()
      dt = love.timer.getDelta()
    end
 
    -- Call update and draw
    --lovebird.update()
    spheret=math.clamp(spheret-dt,0,1)
    if love.update then love.update(dt) end -- will pass 0 if love.timer is disabled
 
    if love.graphics and love.graphics.isActive() then
      love.graphics.clear(love.graphics.getBackgroundColor())
      love.graphics.origin()
      if love.draw then love.draw() end
      if core.draws and type(core.draws)=="table" then
        for n,s in ipairs(core.draws) do
          if type(s)=="function" then
            love.graphics.origin()
            s()
          end
        end
      end
      love.graphics.present()
    end
 
    if love.timer then love.timer.sleep(0.001) end
  end
 
end
end
function core.init()
  require("core.preinit")
  require("core.serial")
  require("core.settings")
  require("core.ad")
  require("core.bytecode")
  require("core.essentials")
  require("core.client")
end
return core