local core=require("core")
core.cursorimg=love.graphics.newImage("cursor.png")
core.draws={}
do
  fontsizes={}
  local crf=love.graphics.newFont
  function love.graphics.newFont(f,s)
    local size=s or f
    local font=crf(f,s)
    fontsizes[font]=size
    return font
  end
  local font=love.graphics.newFont(12)
  local text=love.graphics.newText(font)
  function love.graphics.setFont(font2)
    font=font2
    text:setFont(font)
  end
  local size=12
--  local fsize=12
  local function getScale()
    local scale=size/fontsizes[font]
    return scale
  end
  function core.getFontScale(font)
    return fontsizes[font]/size
  end
  function core.setTextSize(size2)
    size=size2 end
  function love.graphics.print(texts,x,y,r,sx,sy,...)
    local scale=getScale()
    text:set(texts)
    local sx=sx or 1
    local sy=sy or sx
    love.graphics.draw(text,x,y,r,sx*scale,sy*scale,...)
  end
  function love.graphics.printf(texts,x,y,limit,align,r,sx,sy,...)
    local scale=getScale()
    local sx=sx or 1
    local sy=sy or sx
    text:setf(texts,(limit or love.graphics.getWidth())/scale,align or "left")
    love.graphics.draw(text,x,y,0,sx*scale,sy*scale,...)
  end
end
do
  if love.window and love.graphics then
    local wt,ht=800,600
    function core.setInnerDimensions(w,h)
      wt,ht=w,h
      return true
    end
    local gwidth,gheight=love.graphics.getWidth,love.graphics.getHeight
    local orig=love.graphics.origin
    local scl=love.graphics.scale
    function core.getRealDimensions()
      return gwidth(),gheight()
    end
    function core.getDimensionsRate()
      return wt/gwidth(),ht/gheight()
    end
    local clsenabled=true
    function core.setClear(b)
      clsenabled = not not b
    end
    core.origin=orig
    function love.graphics.origin()
      orig()
      scl(gwidth()/wt,gheight()/ht)
    end
    function love.graphics.getWidth()
      return wt
    end
    function love.graphics.getHeight()
      return ht
    end
    local cls=love.graphics.clear
    function love.graphics.clear()
      if clsenabled then
        return cls()
      end
    end
    if love.mouse then
      local m =love.mouse
      local function wrap(func)
        return function(x,y,...)
          local x,y=x~=nil and (x*(gwidth()/wt)) or nil,y ~= nil and (y*(gheight()/ht)) or nil
          local resx,resy=func(x,y,...)
          return resx~= nil and resx*(wt/gwidth()) or nil,resy~= nil and resy*(ht/gheight()) or nil,resx,resy
        end
      end
      m.setPosition = wrap(m.setPosition)
      m.getPosition = wrap(m.getPosition)
      m.getX=function()
        local resx,resy=m.getPosition()
        return resx,resx*(gheight()/ht)
      end
      m.getY=function()
        local resx,resy=m.getPosition()
        return resy,resy*(gwidth()/wt)
      end
      local setx=m.setX
      m.setX=function(x)
        setx(x*(gwidth()/wt))
      end
      local sety=m.setY
      m.setY=function(y)
        sety(y*(gheight()/ht))
      end
    end
  end
end
do
  local rect=love.graphics.rectangle
  local texture=false
  function love.graphics.setRectangleTexture(x)
    texture=x
  end
  function love.graphics.rectangle(mode,x,y,w,h)
    if texture and mode=="fill" then
      love.graphics.draw(texture,x,y,r,w/texture:getWidth(),h/texture:getHeight())
    else
      rect(mode,x,y,w,h)
    end
  end
end
do
  local tstr=tostring
  function tostring(t)
    if type(t)=="table" then
      local res=core.s.serialize(t,nil,true)
      if res then
        return res
      else
        --print("TOSTRING Error!")
        return tstr(t)
      end
    end
    return tstr(t)
  end
end
    function math.clamp(n,s1,s2)
      return math.max(s1,math.min(s2,n))
    end
  do
    local counter={}
    function counter:step()
      self.prevtime=self.time
      self.time=love.timer.getTime()
    end
    function counter:getDelta()
      if self.prevtime and self.time then
        return self.time-self.prevtime
      else
        return 0
      end
    end
    function counter:getFPS()
      return 1/self:getDelta()
    end
    function core.createcounter()
      return setmetatable({},{__index=counter,__metatable={}})
    end
  end
do
  buttonpresses={}
  notbuttonpresses={}
  local buttons={
    ["5_1"]="left",
    ["5_2"]="down",
    ["5_3"]="right",
    ["4_1"]="m",
    ["4_2"]="up",
    ["4_3"]="r",
    ["4_4"]="return",
    ["4_5"]="return",
    ["5_4"]="space",
    ["5_5"]="space"
  }
  local buttons2={
    ["1_1"]={"left","up"},
    ["1_2"]={"up"},
    ["1_3"]={"right","up"},
    ["2_1"]={"left"},
    ["2_2"]={},
    ["2_3"]={"right"},
    ["3_1"]={"left","down"},
    ["3_2"]={"down"},
    ["3_3"]={"down","right"}
  }
  local function super(t)
    local res=0
    for k,v in ipairs(t) do
      res=res+v
    end
    return res/#t
  end
  -- if not love.mouse.hasCursor() then
    -- local mx,my=love.graphics.getWidth()/2,love.graphics.getHeight()/2
    -- function love.mouse.getPosition()
      -- local x,y={},{}
      -- local rx,ry=core.getDimensionsRate()
      -- for k,v in pairs(notbuttonpresses) do
        -- local posx,posy=love.touch.getPosition(v)
        -- posx=posx*rx
        -- posy=posy*ry
        -- table.insert(x,posx)
        -- table.insert(y,posy)
      -- end
      -- if not next(notbuttonpresses) then
        -- return mx,my
      -- end
      -- local x2,y2=super(x),super(y)
      -- mx,my=x2,y2
      -- return x2,y2
    -- end
    -- function love.mouse.getX()
      -- local x,y=love.mouse.getPosition()
      -- return x
    -- end
    -- function love.mouse.getY()
      -- local x,y=love.mouse.getPosition()
      -- return y
    -- end
  -- end
  function core.teste(eventname,a,b,c,d,e,f)
    if not love.mouse.hasCursor() then
      if eventname=="mousepressed" or eventname=="mousereleassed" then
        x,y,key,istouch=a,b,c,d
      elseif eventname=="touchpressed" or eventname=="touchreleased" then
        id,x,y=a,b,c
      elseif eventname=="touchmoved" then
        id,x,y,dx,dy=a,b,c,d,e
      elseif eventname=="mousemoved" then
        x,y,dx,dy=a,b,c,d
      else
        return nil
      end
      local function getkey(x,y,wx,hx,w,h)
        local areaX=w/wx
        local areaY=h/hx
        local function clamp(x,c1,c2)
          return math.min(c2,math.max(x,c1))
        end
        local rx,ry=math.floor(clamp(x,0,w-1)/areaX)+1,math.floor(clamp(y,0,h-1)/areaY)+1
        return rx,ry
      end
      if x and y then
        local realx,realy=x,y
        local kx,ky=getkey(x or error("Err!"),y or error("Err!"),2,2,love.graphics.getWidth(),love.graphics.getHeight())
        local w,h=love.graphics.getWidth(),love.graphics.getHeight()
        local isGamepad=core.isInside(realx,realy,w/10*7,h/10*7,w/10*3,h/10*3)
        local gx,gy=getkey(realx-w/10*7,realy-h/10*7,3,3,w/10*3,h/10*3)
        local x,y=getkey(x,y-(h/3),5,5,w/3*2,h/3*2)
        --print((x-1)*(love.graphics.getWidth()/3*2/3),(y-1)*(love.graphics.getHeight()/3*2/3))
        --print(y,x,buttons[y.."_"..x])
        if eventname=="mousepressed" or eventname=="mousereleased" then
          if buttons[y.."_"..x] then
            return true
          end
        end
        if eventname=="mousemoved" then
            if buttons[y.."_"..x] then
              return true
            end
          end
        if eventname=="touchpressed" then
            print(id)
            if buttons[y.."_"..x] and not isGamepad then
              buttonpresses[id]={id=id,btn=buttons[y.."_"..x]}
              if type(buttons[y.."_"..x]) == "string" then
                love.event.push("keypressed",buttons[y.."_"..x])
                print("TOUCHED VIRTUAL BUTTON "..buttons[y.."_"..x])
              elseif type(buttons[y.."_"..x])=="number" then
                love.event.push("mousepressed",realx,realy,true)
              else
                print("ERROR TOUCHING VIRTUAL BUTTON ("..y.."_"..x..")")
              end
            return true
            elseif isGamepad then
              if buttons2[gy.."_"..gx] then
              buttonpresses[id]={id=id,btn=buttons2[gy.."_"..gx],gmp=true}
              for k,s in ipairs(buttons2[gy.."_"..gx]) do
                if type(s) == "string" then
                  love.event.push("keypressed",s)
                  print("TOUCHED VIRTUAL BUTTON "..s)
                elseif type(s)=="number" then
                  love.event.push("mousepressed",realx,realy,true)
                else
                  print("ERROR TOUCHING VIRTUAL BUTTON ("..y.."_"..x..") "..tostring(s))
                end
              end
              return true
            else
              notbuttonpresses[id]=id
              print("ERROR TOUCHING VIRTUAL BUTTON ("..y.."_"..x..") "..tostring(buttons[y.."_"..x]).." ("..gy.."_"..gx..")")
            end
          end
        end
        if eventname=="touchmoved" and buttonpresses[id] then
            local btn=buttons[y.."_"..x]
            local btn2=buttons2[gy.."_"..gx]
            if btn ~= buttonpresses[id].btn and not buttonpresses[id].gmp then
              local btnx=buttonpresses[id].btn
              if type(btnx)=="string" then
                love.event.push("keyreleased",btnx)
              else
                love.event.push("mousereleased",love.mouse.getX(),love.mouse.getY(),btnx)
              end
              if btn then
                if type(buttons[y.."_"..x]) == "string" then
                  love.event.push("keypressed",buttons[y.."_"..x])
                else
                  love.event.push("mousepressed",realx,realy,buttonpresses[id].btn,true)
                end
              end
              buttonpresses[id].btn=btn
            elseif buttonpresses[id].gmp and buttonpresses[id].btn ~= btn2 then
              local btnx=buttonpresses[id].btn
              if type(btnx)=="string" then
                love.event.push("keyreleased",btnx)
              elseif type(btnx)=="number" then
                love.event.push("mousereleased",love.mouse.getX(),love.mouse.getY(),btnx)
              elseif type(btnx)=="table" then
                for k,s in ipairs(btnx) do
                  if type(s) == "string" then
                    love.event.push("keyreleased",s)
                  else
                    love.event.push("mousereleased",realx,realy,buttonpresses[id].btn,true)
                  end
                end
              end
              --if btn and not isGamepad then
              --  if type(buttons[y.."_"..x]) == "string" then
              --    love.event.push("keypressed",buttons[y.."_"..x])
              --  else
              --    love.event.push("mousepressed",realx,realy,buttonpresses[id].btn,true)
              --  end
              --  buttonpresses[id].btn=btn
              if btn2 and isGamepad then
                for k,s in ipairs(btn2) do
                  if type(s) == "string" then
                    love.event.push("keypressed",s)
                  else
                    love.event.push("mousepressed",realx,realy,buttonpresses[id].btn,true)
                  end
                end
                buttonpresses[id].btn=buttons2[gy.."_"..gx]
              end
            end
            return true
          end
        if eventname=="touchreleased" then
            print(id)
            if buttonpresses[id] then
              local btnx=buttonpresses[id].btn
              print("RELEASED VIRTUAL BUTTON "..tostring(btnx))
              if type(btnx)=="string" then
                love.event.push("keyreleased",btnx)
              elseif type(btnx)=="number" then
                love.event.push("mousereleased",love.mouse.getX(),love.mouse.getY(),btnx)
              elseif type(btnx)=="table" then
                for k,s in ipairs(btnx) do
                  if type(s) == "string" then
                    love.event.push("keyreleased",s)
                  else
                    love.event.push("mousereleased",realx,realy,buttonpresses[id].btn,true)
                  end
                end
              end
            end
            notbuttonpresses[id]=nil
            buttonpresses[id]=nil
            return true
          end
      end
    end
  end
end
table.insert(core.draws,function()      love.graphics.origin()
      local r,g,b,a=love.graphics.getColor()
      love.graphics.setColor(255,255,255,255)
      local xw,yh=core.getRealDimensions()
      xw2,yh2=love.graphics.getWidth()/xw,love.graphics.getHeight()/yh
      local _,mx=love.mouse.getX()
      local _,my=love.mouse.getY()
      local x=""
      for k,v in pairs(buttonpresses) do
        x=x..tostring(v.id).." "..tostring(v.btn).." "..tostring(v.gmp).."\n"
      end
      --love.graphics.printf(x,10,10,love.graphics.getWidth())
      -- local w,h=love.graphics.getWidth(),love.graphics.getHeight()
      -- love.graphics.rectangle("line",0,h-(h/3*2),w/3*2,h/3*2)
      -- local singlex=w/3*2/5
      -- local singley=h/3*2/5
      -- for x=0,4 do
        -- for y=0,4 do
          -- love.graphics.rectangle("line",singlex*x,h-(h/3*2)+singley*y,singlex,singley)
        -- end
      -- end
      love.graphics.setColor(255,255,255,255)
      --for r=1,20 do
      --love.mouse.setVisible(true)
      --love.graphics.draw(core.cursorimg,love.mouse.getX(),love.mouse.getY(),0,1,1,core.cursorimg:getWidth()/2,core.cursorimg:getHeight()/2)
      --end
      love.graphics.setColor(r,g,b,a)end)
