﻿core = require("core")
core.init()
local socket=require("socket")
  love.graphics.setDefaultFilter("nearest","nearest")
core.error=love.audio.newSource("error.wav")core.error:setRelative(true)
local bgi=love.graphics.newImage("bg.png")
core.click = love.audio.newSource("click.wav","static")
local bg=love.audio.newSource("bg.mp3","stream")bg:setRelative(true)
local bgg=love.audio.newSource("gasterold.mp3","stream")bgg:setRelative(true)
bg:setLooping(true)
bgg:setLooping(true)
local defaults={name="",ip=""}
local sans=love.audio.newSource("sans.mp3","stream")
local sansbg=love.graphics.newImage("sans.png")sans:setRelative(true)
local gasterbg=love.graphics.newImage("gasterbg.png")
local rectbg=love.graphics.newImage("button.png")
local gastered=false
function core.playconfm(...)
  local w,h=love.window.getMode()
  return core.custommenu({
    {
      title="Graphics: "..(core.lowq and "low" or "high"),
      action="tg"
    },
    {
      title="Screen Resolution: "..w.."x"..h,
      action="chres"
    },
    {
      title="Prefered traffic consumption: "..core.maxtraffic.." MB/sec",
      action="traffic"
    },
    {
      title="Keyboard Controls: "..(core.controls == "n/o" and "WASD:New, Arrows:Old" or "WASD:Old, Arrows:New"),
      action="controls"
    },
    {
      title="On-screen Joystick: "..(core.joysticke and "enabled" or "disabled"),
      action="joystick"
    },
    {
      title="Music: "..(core.music and "enabled" or "disabled"),
      action="music"
    },
    {
      title="Sounds: "..(core.sounds and "enabled" or "disabled"),
      action="sounds"
    },
    {
      title="Authors",
      action="authors"
    },
    {
      title="Help",
      action="help",
    },
    {
      title="Back",
      action="back"
    }
  },"Settings and help",...)
end
function core.playmm(...)
  local w,h=love.window.getMode()
  return core.custommenu({
    {
      title="Play |>",
      action="play"
    },
    {
      title="Nickname: "..core.nickname,
      action="chnick"
    },
    {
      title="Settings and help",
      action="conf"
    },
    {
      title="Quit",
      action="quit",
    }
  },(gastered and "GasterWar v" or "CarWar v")..core.version,...)
end
function core.playpm(...)
  return core.custommenu({
    {
      title="Host a game",
      action="host",
    },
    {
      title="Join a game",
      action="join"
    },
    {
      title="",
      ina=true
    },
    {
      title="<- Back",
      action="back"
    },
  },"Select action",...)
end
function core.playhm(bots,map,...)
  return core.custommenu({
    {
      title="Bots: "..bots,
      action="bots",
    },
    {
      title="Map: "..map,
      action="map"
    },
    {
      title="",
      ina=true
    },
    {
      title="Play!",
      action="play"
    },
    {
      title="<- Back",
      action="back"
    },
  },"Select action",...)
end
function game()
  math.randomseed(os.time())
  for n=1,10 do
    math.random()
  end
  core.loadSettings()
  love.filesystem.mount(love.filesystem.getSourceBaseDirectory(),"data")
  love.window.setMode(core.settings.resolution[1],core.settings.resolution[2],{fullscreen=core.settings.fullscreen,fullscreentype="exclusive",resizable=true})
  local font = love.graphics.newFont("GEORGIAZ.TTF",256)
  local pfont=love.graphics.newFont("Papyrus.ttf",256)
  font:setFilter("linear","linear")
  --font:setLineHeight(12/font:getHeight())
  core.setFont(font)
  function settings()
    core.playsettings()
    core.step()
  end
  function lserver()
    local name=core.read("Enter your nickname: ")
    core.playclient("127.0.0.1")
  end
  function getIP() local s = socket.udp() s:setpeername("192.168.137.1",80) local ip, _ = s:getsockname() s:close() return ip end
  function umusic()if core.music then
    if not gastered then
      bg:play()
      bgg:stop()
    else
      bg:stop()
      bgg:play()
    end
    else
      bg:stop()
      bgg:stop()
    end
    love.audio.setDistanceModel("none")
    love.audio.setPosition(0,0,0)
  end
  function client(name)
    local name = name or core.read("Enter your nickname: ",defaults.name,(gastered and gasterbg or bgi))
    if string.find(string.lower(name),"sans") then
      sans:play()
      bg:stop()
      bgg:stop()
      core.message("nope.",sansbg,64)
      sans:stop()
      return
    end
    if string.find(name,"Terraria") then
      core.message("Fatal error. this game is not terraria. Error code: #TERRARIA_ERROR")
      love.event.quit()
      return
    end
    if name == "TC1061" then
      core.message("You will use my nickname")
    end
    if name=="Papyrus" then
      core.setFont(pfont)
    end
    if name=="Gaster" then
      if not gastered then
        gastered=true
        core.message("You shouldn't do that. Now your game is gastered. Mua-ha-ha-ha-ha!\n P.S. NYEH-HEH-HEH!")
        --table.insert(core.draws,function() for n=1,math.random(1000,2000) do local color={love.graphics.getColor()} love.graphics.setColor(math.random(1,255),math.random(1,255),math.random(1,255),math.random(1,255)) love.graphics.circle("fill",math.random(0,love.graphics.getWidth()),math.random(0,love.graphics.getHeight()),math.random(1,2)) love.graphics.setColor(unpack(color)) end end)
      end
      bg:stop()
      bgg:play()
    end
    if gastered and name ~= "Gaster" then
      core.reset()
      bg:stop()
      bgg:stop()
      local wdg=love.audio.newSource("nogaster.mp3")
      love.mouse.setVisible(false)
      love.mouse.setGrabbed(true)
      wdg:play()
      while true do core.step()
      if wdg:isStopped() then
        love.event.quit()
      end end
    end
    local udp=socket.udp()
    local ips={}
    local msg="Please wait..."
    function love.draw()
      if core.font then
        love.graphics.setFont(core.font)
      end
      local width,height=love.graphics.getHeight(),love.graphics.getWidth()
      love.graphics.printf(msg, 0, love.graphics.getHeight()/2, love.graphics.getWidth()/2,"center",0,2)
    end
    core.step()
    msg="Please wait. Sending requests..."
    local mainip=getIP()
    local ipparts={}
    for v in mainip:gmatch("(%d+)") do
      table.insert(ipparts,v)
    end
    mainip2=string.format("%i.%i.%i.",unpack(ipparts))
    --print(mainip)
    udp:setsockname("*",30518)
    --for n=1,10 do
    for n2=0,255 do
      --print(mainip2..n2)
      for n=1,2 do
      udp:sendto("x",mainip2..n2,30519)end
      --print(mainip2..n2)
      msg="Please wait. Sending requests, "..math.floor(n2/255*100).."% sent"
    end
    core.step()
    --end
    --udp:sendto("\1\n",mainip,30518)
    udp:settimeout(0.1)
    msg="Please wait. Searching for servers..."
    local n=0
    local time=1
    while true do
      n=n+1
      msg="Please wait. Searching for servers..."
      local starttime=os.clock()
      local line,ip,port=udp:receivefrom()
      --print(time,port)
      if port==30519 then
        if not line then
          --print("No answer")
          --break
        elseif line=="y" then
          time=1
          print(ip)
          local hasip=false
          for n,s in ipairs(ips) do
            if s==ip then
              hasip=true
            end
          end
          if not hasip then
          table.insert(ips,ip)
          print(#ips)
          end
        else
          print("Invalid server")
        end
      end
      if time <= 0 then
        print("Timeout")
        break
      end
      if n/10 == math.floor(n/10) then 
      core.step()
      n=0
      end
      time=time-(os.clock()-starttime)
    end
    local buttons={{title="",ina=true},{title="Direct connect",action={"custom"}},{title="Refresh",action={"r"}},{title="Cancel",action={"c"}}}
    for k,v in ipairs(ips) do
      table.insert(buttons,1,{title=(v == mainip and v.." (local)" or v),action={"connect",v}})
    end
    if #ips==0 then
      buttons[1]={title="No servers detected in local network",ina=true}
    end
    local ipport="127.0.0.1"
    local action=core.custommenu(buttons,"Select server",1,{bg=(gastered and gasterbg or bgi),rectbg=rectbg})
    if action[1]=="custom" then
      udp:close()
      ipport = core.read("Enter server IP: ",defaults.ip)
    elseif action[1]=="connect" then
      udp:close()
      ipport=action[2]
    elseif action[1]=="r" then
      udp:close()
      return true,name
    elseif action[1]=="c" then
      udp:close()
      return
    end
    core.fadeout()
    defaults.name,defaults.ip = name,ipport
    bg:stop()
    bgg:stop()
    print("SERVER: "..ipport)
    core.playclient(ipport,name,rectbg)
    love.audio.stop()
    core.setFont(font)
  end
  local active,result,offset=1
  love.window.setTitle("CarWar")
  --core.startserver((gastered and gasterbg or bgi),rectbg)
  --core.stopserver((gastered and gasterbg or bgi))
  core.initAd()
  core.showAd()
  while true do
    umusic()
    result,active,offset=core.playmm(active,{bg=(gastered and gasterbg or bgi),rectbg=rectbg,offset=offset})
    print("User pressed "..result)
    if result=="play" then
      local active,offset=1
      while true do
        local result,act,off=core.playpm(active,{bg=(gastered and gasterbg or bgi),rectbg=rectbg,offset=offset})
        active,offset=act,off
        if result=="host" then
          local active,offset=1
          local bots=0
          local map,mapname
          local maps=love.filesystem.getDirectoryItems("maps")
          local rmaps={}
          for k,v in pairs(maps) do
            local name=v
            for n=#v,1,-1 do
              if v:sub(n,n)=="." then
                name=v:sub(1,n-1)
              end
            end
            table.insert(rmaps,1,{k,name})
          end
          local map,mapname=unpack(rmaps[math.random(1,#rmaps)])
          while true do
            local result,act,off=core.playhm(bots,mapname,active,{bg=(gastered and gasterbg or bgi),rectbg=rectbg,offset=offset})
            active,offset=act,off
            if result=="map" then
              local maps=love.filesystem.getDirectoryItems("maps")
              local buttons={{title="<- Cancel",action="cancel"}}
              for k,v in pairs(maps) do
                local name=v
                for n=#v,1,-1 do
                  if v:sub(n,n)=="." then
                    name=v:sub(1,n-1)
                  end
                end
                table.insert(buttons,1,{title=name,action={k,name}})
              end
              result=core.custommenu(buttons,"Select map",1,{bg=(gastered and gasterbg or bgi),rectbg=rectbg})
              if result~="cancel" then
              map,mapname=unpack(result)
              end
            elseif result=="bots" then
              bots=tonumber(core.read("Enter bot count: ",nil,(gastered and gasterbg or bgi))) or bots
            elseif result=="play" then
              local ok=core.startserver(bots,map)
              if not ok then
                core.message("An error occurred and you can't host a game :(")
              else
                bg:stop()
                bgg:stop()
                core.playclient("127.0.0.1",core.nickname,rectbg)
                core.showAd()
                core.stopserver()
              end
            elseif result=="back" then
              break
            end
          end
        elseif result=="join" then
          local ok=client(core.nickname)
          while ok do
            ok=client(core.nickname)
          end
          core.showAd()
        elseif result=="back" then
          break
        end
      end
    elseif result=="chnick" then
      core.nickname=core.read("Enter your nickname: ",core.nickname,(gastered and gasterbg or bgi))
      core.saveSettings()
    elseif result=="conf" then
      local active,offset=1
      while true do
        umusic()
        local result,act,off=core.playconfm(active,{bg=(gastered and gasterbg or bgi),rectbg=rectbg,offset=offset})
        active,offset=act,off
        if result=="tg" then
          core.lowq=not core.lowq
        elseif result=="music" then
          core.music= not core.music
        elseif result=="sounds" then
          core.sounds=not core.sounds
        elseif result=="authors" then
          core.credits((gastered and gasterbg or bgi))
        elseif result=="chres" then
          local modes = love.window.getFullscreenModes()
          table.sort(modes, function(a, b) return a.width*a.height < b.width*b.height end)   -- sort from smallest to largest
          local w,h=love.window.getMode()
          local buttons={{title="Current Resolution: "..w.."x"..h,ina=true},{title="Cancel",action="c"}}
          for k,v in ipairs(modes) do
            table.insert(buttons,{title=v.width.."x"..v.height,action=k})
          end
          local act=core.custommenu(buttons,"Select resolution",1,{bg=(gastered and gasterbg or bgi),rectbg=rectbg})
          if act=="c" then
          elseif modes[act] then
            love.window.setMode(modes[act].width,modes[act].height,{fullscreentype="exclusive",fullscreen=love.window.getFullscreen(),resizable=true})
          end
        elseif result=="help" then
          for k,v in ipairs(core.help) do
            core.message(v,(gastered and gasterbg or bgi))
          end
        elseif result=="controls" then
          if core.controls=="n/o" then
            core.controls="o/n"
          else
            core.controls="n/o"
          end
        elseif result=="joystick" then
          core.joysticke=not core.joysticke
        elseif result=="traffic" then
          if core.maxtraffic==0.1 then
            core.maxtraffic=0.5
          elseif core.maxtraffic==0.5 then
            core.maxtraffic=1
          elseif core.maxtraffic==1 then
            core.maxtraffic=10
          elseif core.maxtraffic==10 then
            core.maxtraffic=0.05
          elseif core.maxtraffic==0.05 then
            core.maxtraffic=0.1
          else
            core.maxtraffic=0.1
          end
        elseif result=="back" then
          core.saveSettings()
          break
        end
      end
    elseif result == "quit" then
      love.event.quit()
    end
    --core.step()
  end
end
core.start(game)